/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.community.controller;

import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.community.dto.AgencyMngDelDTO;
import org.springblade.community.entity.Building;
import org.springblade.community.entity.Residential;
import org.springblade.community.entity.Room;
import org.springblade.community.service.*;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.BladeUser;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.system.expand.feign.IConfClient;
import org.springblade.system.expand.feign.IOrgPositionClient;
import org.springblade.system.expand.util.QueryWrapperUtil;
import org.springframework.boot.autoconfigure.info.ProjectInfoProperties;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.community.entity.Unit;
import org.springblade.community.vo.UnitVO;
import org.springblade.community.wrapper.UnitWrapper;
import org.springblade.core.boot.ctrl.BladeController;

import java.util.Map;

/**
 * 单元表 控制器
 *
 * @author BladeX
 * @since 2021-03-29
 */
@RestController
@AllArgsConstructor
@RequestMapping("/unit")
@Api(value = "单元表", tags = "单元表接口")
public class UnitController extends BladeController {

	private final IUnitService unitService;
	private final IBuildingService buildingService;
	private final IResidentialService residentialService;
	private final IFloorService floorService;
	private final IRoomService roomService;

	private final IOrgPositionClient orgPositionClient;
	private final IConfClient confClient;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入unit")
	public R<UnitVO> detail(Unit unit) {
		Unit detail = unitService.getOne(Condition.getQueryWrapper(unit));
		return R.data(UnitWrapper.build().entityVO(detail));
	}

	/**
	 * 分页 单元表
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入unit")
	public R<IPage<UnitVO>> list(@RequestParam Map<String,Object> unit, Query query, BladeUser bladeUser) {
		Long buildingId = null;
		Long residentialId = null;
		if(unit.get("buildingId") != null){
			buildingId = Long.parseLong(String.valueOf(unit.get("buildingId")));
			unit.remove("buildingId");
		}
		if(unit.get("residentialId") != null){
			residentialId = Long.parseLong(String.valueOf(unit.get("residentialId")));
			unit.remove("residentialId");
		}
		LambdaQueryWrapper<Unit> unitLambdaQueryWrapper = new QueryWrapperUtil<Unit>().getBasicQueryWrapperByMap(Unit::getOrgPosition, unit,new Unit(), bladeUser, orgPositionClient);
		unitLambdaQueryWrapper.eq(residentialId != null, Unit::getResidentialId, residentialId);
		unitLambdaQueryWrapper.eq(buildingId != null, Unit::getBuildingId, buildingId);
		IPage<Unit> pages = unitService.page(Condition.getPage(query), unitLambdaQueryWrapper);
		return R.data(UnitWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页 单元表
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入unit")
	public R<IPage<UnitVO>> page(UnitVO unit, Query query) {
		IPage<UnitVO> pages = unitService.selectUnitPage(Condition.getPage(query), unit);
		return R.data(pages);
	}

	/**
	 * 新增 单元表
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入unit")
	public R save(@Valid @RequestBody Unit unit) {
		return R.status(unitService.save(unit));
	}

	/**
	 * 修改 单元表
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入unit")
	public R update(@Valid @RequestBody Unit unit) {
		return R.status(unitService.updateById(unit));
	}

	/**
	 * 新增或修改 单元表
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入unit")
	public R submit(@Valid @RequestBody Unit unit) {
		Residential residential = residentialService.getById(unit.getResidentialId());
		Assert.notNull(residential, "找不到对应小区！");
		Assert.notNull(unit.getBuildingId(),"单元所属楼栋不能为空");
		Building building = buildingService.getById(unit.getBuildingId());
		Assert.notNull(building,"单元对应的楼栋不存在");

		if (unit.getId() == null) {
			residential.setUnitCount(residential.getUnitCount() == null ? 1 : residential.getUnitCount() + 1);
			building.setUnitCount(building.getUnitCount() == null ? 1 : building.getUnitCount() + 1);
			if (unitService.save(unit)) {
				residentialService.updateById(residential);
				buildingService.updateById(building);
			}
		}
		unit.setAgencyId(building.getAgencyId());
		unit.setAgencyName(building.getAgencyName());
		unit.setResidentialId(building.getResidentialId());
		unit.setResidentialName(building.getResidentialName());
		unit.setBuildingName(building.getName());
		unit.setOrgPosition(building.getOrgPosition());
		unit.setPic(confClient.removePrefix(unit.getPic()));
		return R.status(unitService.saveOrUpdateUnit(unit));
	}

	/**
	 * 物理删除，及其所有子节点 楼层...房间
	 */
	@PostMapping("/removeAll")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	@Transactional(rollbackFor = Exception.class)
	public R remove(@RequestParam Long id) {
		AgencyMngDelDTO delDTO = new AgencyMngDelDTO();
		delDTO.setUnitId(id);
		//物理删除单元
		unitService.delete(delDTO);
		//物理删除楼层
		floorService.delete(delDTO);
		//物理删除房间
		roomService.delete(delDTO);
		return R.status(true);
	}


	/**
	 * 删除 单元表
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(unitService.deleteLogic(Func.toLongList(ids)));
	}


}
